from abc import ABC, abstractmethod

from cpl_query.extension import List

from bot_data.model.api_key import ApiKey


class ApiKeyRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_api_keys(self) -> List[ApiKey]:
        pass

    @abstractmethod
    def get_api_key(self, identifier: str, key: str) -> ApiKey:
        pass

    @abstractmethod
    def get_api_key_by_id(self, id: int) -> ApiKey:
        pass

    @abstractmethod
    def get_api_key_by_key(self, key: str) -> ApiKey:
        pass

    @abstractmethod
    def add_api_key(self, api_key: ApiKey):
        pass

    @abstractmethod
    def update_api_key(self, api_key: ApiKey):
        pass

    @abstractmethod
    def delete_api_key(self, api_key: ApiKey):
        pass
