from abc import ABC, abstractmethod

from cpl_query.extension import List

from bot_data.model.short_role_name import ShortRoleName


class ShortRoleNameRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_short_role_names(self) -> List[ShortRoleName]:
        pass

    @abstractmethod
    def get_short_role_name_by_id(self, id: int) -> ShortRoleName:
        pass

    @abstractmethod
    def find_short_role_names_by_role_id(self, role_id: int) -> List[ShortRoleName]:
        pass

    @abstractmethod
    def get_short_role_names_by_server_id(self, id: int) -> List[ShortRoleName]:
        pass

    @abstractmethod
    def add_short_role_name(self, short_role_name: ShortRoleName):
        pass

    @abstractmethod
    def update_short_role_name(self, short_role_name: ShortRoleName):
        pass

    @abstractmethod
    def delete_short_role_name(self, short_role_name: ShortRoleName):
        pass
