from bot_data.abc.history_table_abc import HistoryTableABC


class AchievementHistory(HistoryTableABC):
    def __init__(
        self,
        name: str,
        description: str,
        attribute: str,
        operator: str,
        value: str,
        server: int,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._name = name
        self._description = description
        self._attribute = attribute
        self._operator = operator
        self._value = value
        self._server = server

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @property
    def description(self) -> str:
        return self._description

    @property
    def attribute(self) -> str:
        return self._attribute

    @property
    def operator(self) -> str:
        return self._operator

    @property
    def value(self) -> str:
        return self._value

    @property
    def server(self) -> int:
        return self._server
