from cpl_core.dependency_injection import ServiceProviderABC
from cpl_discord.service import DiscordBotServiceABC

from bot_data.abc.history_table_abc import HistoryTableABC


class AutoRoleRuleHistory(HistoryTableABC):
    def __init__(
        self,
        auto_role: int,
        discord_emoji_name: str,
        discord_role_id: int,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)
        self._auto_role_rule_id = id
        self._auto_role = auto_role
        self._discord_emoji_name = discord_emoji_name
        self._discord_role_id = discord_role_id

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._auto_role_rule_id

    @property
    def auto_role(self) -> int:
        return self._auto_role

    @property
    def emoji_name(self) -> str:
        return self._discord_emoji_name

    @property
    def role_id(self) -> int:
        return self._discord_role_id

    @property
    @ServiceProviderABC.inject
    def role_name(self, bot: DiscordBotServiceABC) -> str:
        guild = bot.get_guild(self.auto_role.server.discord_id)
        return guild.get_role(self.role_id).name
