from datetime import datetime

from cpl_core.database import TableABC

from bot_data.model.api_key import ApiKey
from bot_data.model.server import Server


class GameServer(TableABC):
    def __init__(
        self,
        name: str,
        server: Server,
        api_key: ApiKey,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._name = name
        self._server = server
        self._api_key = api_key

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @name.setter
    def name(self, value: str):
        self._name = value

    @property
    def server(self) -> Server:
        return self._server

    @server.setter
    def server(self, value: Server):
        self._server = value

    @property
    def api_key(self) -> ApiKey:
        return self._api_key

    @api_key.setter
    def api_key(self, value: ApiKey):
        self._api_key = value

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `GameServers`;
        """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `GameServers`
            WHERE `Id` = {id};
        """
        )

    @staticmethod
    def get_select_by_api_key_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `GameServers`
            WHERE `ApiKeyId` = {id};
        """
        )

    @staticmethod
    def get_select_by_server_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `GameServers`
            WHERE `ServerId` = {id};
        """
        )

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `GameServers`
            WHERE `UserId` = {id};
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `GameServers` (
                `Name`, `ServerId`, `ApiKeyId`
            ) VALUES (
                '{self._name}',
                {self._server.id},
                {self._api_key.id}
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
            UPDATE `GameServers`
            SET `Name` = '{self._name}'
            WHERE `Id` = {self._id};
        """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `GameServers`
            WHERE `Id` = {self._id};
        """
        )

    @staticmethod
    def delete_by_user_id_string(id: int) -> str:
        return str(
            f"""
            DELETE FROM `GameServers`
            WHERE `UserId` = {id}
    """
        )
