import { Component, OnInit } from "@angular/core";
import { Router } from "@angular/router";
import { SettingsService } from "../../../../services/settings/settings.service";

@Component({
  selector: "app-auth-footer",
  templateUrl: "./auth-footer.component.html",
  styleUrls: ["./auth-footer.component.scss"]
})
export class AuthFooterComponent implements OnInit {
  private privacy: string = "";
  private imprint: string = "";

  constructor(
    private settings: SettingsService
  ) {
  }

  ngOnInit(): void {
    this.privacy = this.settings.getPrivacyURL();
    this.imprint = this.settings.getImprintURL();
  }

  public navigateToPrivacy(): void {
    window.open(this.settings.getPrivacyURL(), "_blank");
  }

  public navigateToImprint(): void {
    window.open(this.settings.getImprintURL(), "_blank");
  }

}
